using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework.Content;

namespace AnimationClassLibrary
{
    /// <summary>
    /// Ƭ࣬ౣһؼ֡ϺͶʱ䡣
    /// һModelAnimationClip൱ݹܵе
    /// Microsoft.Xna.Framework.Content.Pipeline.Graphics.AnimationContentʱ
    /// </summary>
    public class ModelAnimationClip
    {
        /// <summary>
        /// ƬεĲų
        /// </summary>
        [ContentSerializer]
        public TimeSpan Duration { get; private set; }

        /// <summary>
        /// ؼ֡
        /// </summary>
        [ContentSerializer(CollectionItemName = "Keyframe")]
        public List<ModelKeyframe> Keyframes { get; private set; }

        /// <summary>
        /// һƬ
        /// </summary>
        public ModelAnimationClip(TimeSpan duration, List<ModelKeyframe> keyframes)
        {
            Duration = duration;
            Keyframes = keyframes;
        }

        // ҪһĹ캯ڴл
        private ModelAnimationClip()
        {
        }

        /// <summary>
        /// һModelAnimationClipϵǰModelAnimationClip
        /// </summary>
        /// <param name="additional"></param>
        public void Merge(ModelAnimationClip additional)
        {
            this.Duration += additional.Duration;
            for (int i=0; i < additional.Keyframes.Count; i++)
            {
                this.Keyframes.Add(additional.Keyframes[i]);
            }
            //¶Թؼ֡ʱȺ
            Keyframes.Sort(CompareKeyframeTimes);
        }

        // չؼ֡ʱComparison
        static int CompareKeyframeTimes(ModelKeyframe a, ModelKeyframe b)
        {
            return a.Time.CompareTo(b.Time);
        }
        
    }
}
