using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;

namespace AnimationClassLibrary
{
    /// <summary>
    /// ࣬һModelAnimationClip͵ĶƬΣڲһƤģеĶ
    /// </summary>
    public class SkinningAnimationData
    {
        /// <summary>
        /// һSkinningData
        /// </summary>
        public SkinningAnimationData(Dictionary<string, ModelAnimationClip> animationClips, List<Matrix> bindPose, List<Matrix> inverseBindPose, List<int> skeletonHierarchy)
        {
            ModelAnimationClips = animationClips;
            BindPose = bindPose;
            InverseBindPose = inverseBindPose;
            SkeletonHierarchy = skeletonHierarchy;
        }

        /// <summary>
        /// XNB deserializer˽й캯
        /// </summary>
        private SkinningAnimationData()
        {
        }

        /// <summary>
        /// ȡƬεļϡЩƬδ洢һDictionaryУƬεƣ"Walk", "Run","JumpReallyHigh"ΪDictionaryļ
        /// </summary>
        [ContentSerializer]
        public Dictionary<string, ModelAnimationClip> ModelAnimationClips { get; private set; }

        /// <summary>
        /// ÿboneBindpose븸boneϵ
        /// </summary>
        [ContentSerializer]
        public List<Matrix> BindPose { get; private set; }

        /// <summary>
        /// ÿboneĶboneռת
        /// </summary>
        [ContentSerializer]
        public List<Matrix> InverseBindPose { get; private set; }

        /// <summary>
        /// Թеÿboneĸbone
        /// </summary>
        [ContentSerializer]
        public List<int> SkeletonHierarchy { get; private set; }
    }
}