using System.Xml;
using AnimationClassLibrary;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Intermediate;

namespace AnimationPipeline
{
    /// <summary>
    /// ȡ.AnimationļĵʵǶIntermediateSerializerķװ
    /// ͿԴXmlImporterһģΨһʶ.Animationļ
    /// </summary>
    [ContentImporter(".Animation", DisplayName = "AnimationData Importer", DefaultProcessor = "AnimationData Processor",CacheImportedData =true)]
    public class AnimationDataImporter : ContentImporter<AnimationData>
    {
        public override AnimationData Import(string filename, ContentImporterContext context)
        {
            AnimationData animationData;
            
            using (XmlReader reader = XmlReader.Create(filename))
            {
                animationData=IntermediateSerializer.Deserialize<AnimationData>(reader, null);
            }

            return animationData;            
        }
    }
}
